/*
 * This file is part of the Panini project at Iowa State University.
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * For more details and the latest version of this code please see
 * http://paninij.org
 * 
 * Contributor(s): Hridesh Rajan
 */

signature Stream {
 void write(String s); 
}

capsule Console () implements Stream {
	void write(String s) { System.out.println(s); }
}

capsule Greeter (Stream s) {
	void greet(){ 
		s.write("Hello World, Signature Style!"); 
	}
}

capsule SignatureExample {
	design {
		Console c; Greeter g;
		g(c);
	}
	void run() {
		g.greet();
	}
}
